=== modified file 'DBUS-API'
--- DBUS-API	2010-09-26 18:32:58 +0000
+++ DBUS-API	2011-03-17 18:14:34 +0000
@@ -104,22 +104,22 @@
    c) Setting this property is equivalent to calling StartChecker() or
       StopChecker().
    
-   d) The creation time of this client object, as a RFC 3339 string.
+   d) The creation time of this client object, as an RFC 3339 string.
    
    e) Setting this property is equivalent to calling Enable() or
       Disable().
    
-   f) The time of the last approval request, as a RFC 3339 string, or
+   f) The time of the last approval request, as an RFC 3339 string, or
       an empty string if this has not happened.
    
-   g) The last time a checker was successful, as a RFC 3339 string, or
-      an empty string if this has not happened.  Setting this property
-      is equivalent to calling CheckedOK(), i.e. the current time is
-      set, regardless of the string sent.  Please always use an empty
-      string when setting this property, to allow for possible future
-      expansion.
+   g) The last time a checker was successful, as an RFC 3339 string,
+      or an empty string if this has not happened.  Setting this
+      property is equivalent to calling CheckedOK(), i.e. the current
+      time is set, regardless of the string sent.  Please always use
+      an empty string when setting this property, to allow for
+      possible future expansion.
    
-   h) The last time this client was enabled, as a RFC 3339 string, or
+   h) The last time this client was enabled, as an RFC 3339 string, or
       an empty string if this has not happened.
    
    i) A raw byte array, not hexadecimal digits.
@@ -140,17 +140,17 @@
     This client will be approved or denied in exactly Timeout
     milliseconds, depending on ApprovedByDefault.  Approve() can now
     usefully be called on this client object.
-
+    
 *** PropertyChanged(s: Property, v: Value)
     The Property on this client has changed to Value.
-
+    
 *** Rejected(s: Reason)
     This client was not given its secret for a specified Reason.
 
 * Copyright
 
-    Copyright © 2010 Teddy Hogeborn
-    Copyright © 2010 Björn Påhlsson
+    Copyright © 2010-2011 Teddy Hogeborn
+    Copyright © 2010-2011 Björn Påhlsson
   
 ** License:
    

=== modified file 'INSTALL'
--- INSTALL	2009-02-15 09:28:06 +0000
+++ INSTALL	2011-03-08 19:09:03 +0000
@@ -4,14 +4,14 @@
   
 ** Operating System
    
-   Debian 5.0 "lenny" or Ubuntu 8.04 "Hardy Heron".
+   Debian 6.0 "squeeze" or Ubuntu 10.10 "Maverick Meerkat".
    
    This is mostly for the support scripts which make sure that the
    client is installed and started in the initial RAM disk environment
    and that the initrd.img file is automatically made unreadable.  The
    server and client programs themselves *could* be run in other
    distributions, but they *are* specific to GNU/Linux systems, and
-   are not intended to be portable to other Unixes.
+   are not written with portabillity to other Unixes in mind.
   
 ** Libraries
    
@@ -39,18 +39,18 @@
 *** Mandos Server
     + GnuTLS 2.4          http://www.gnu.org/software/gnutls/
     + Avahi 0.6.16        http://www.avahi.org/
-    + Python 2.5          http://www.python.org/
+    + Python 2.6          http://www.python.org/
     + Python-GnuTLS 1.1.5 http://pypi.python.org/pypi/python-gnutls/
     + dbus-python 0.82.4  http://dbus.freedesktop.org/doc/dbus-python/
-    + python-ctypes 1.0.0 http://pypi.python.org/pypi/ctypes
     + PyGObject 2.14.2    http://library.gnome.org/devel/pygobject/
+    + Urwid 0.9.8.3       http://excess.org/urwid/
     
     Strongly recommended:
     + fping 2.4b2-to-ipv6 http://www.fping.com/
     
     Package names:
     python-gnutls avahi-daemon python python-avahi python-dbus
-    python-ctypes python-gobject
+    python-gobject python-urwid
    
 *** Mandos Client
     + initramfs-tools 0.85i
@@ -99,16 +99,20 @@
      server computer*.
   
   4. Configure the client to use the correct network interface.  The
-     default is "eth0", and if this needs to be adjusted, it will be
-     necessary to edit /etc/mandos/plugin-runner.conf to uncomment and
-     change the line there.  If that file is changed, the initrd.img
-     file must be updated, possibly using the following command:
+     interface to use is automatically chosen at boot, and if this
+     needs to be adjusted, it will be necessary to edit
+     /etc/initramfs-tools/initramfs.conf to change the DEVICE setting
+     there.  Alternatively, the file /etc/mandos/plugin-runner.conf
+     can be edited to add a "--device" parameter for the
+     mandos-client(8) plugin.  Please note: If any of those files are
+     changed, the initrd.img file must be updated, possibly using the
+     following command:
      
 	# update-initramfs -k all -u
   
   5. On the server computer, start the server by running the command
      For Debian: su -c 'invoke-rc.d mandos start'
-     For Ubuntu: sudo invoke-rc.d mandos start
+     For Ubuntu: sudo service mandos start
      
      At this point, it is possible to verify that the correct password
      will be received by the client by running the command:

=== modified file 'Makefile'
--- Makefile	2010-10-11 17:45:21 +0000
+++ Makefile	2011-03-08 19:41:59 +0000
@@ -23,7 +23,7 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.2.3
+version=1.3.0
 SED=sed
 
 ## Use these settings for a traditional /usr/local install

=== modified file 'NEWS'
--- NEWS	2010-10-11 17:45:21 +0000
+++ NEWS	2011-03-08 19:41:59 +0000
@@ -1,6 +1,14 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
+Version 1.3.0 (2011-03-08)
+* Server:
+** Updated for Python 2.6.
+* Client:
+** Bug fix: Make the password-prompt plugin not conflict with
+   Plymouth.
+** Bug fix: Bug fix: update initramfs also when purging package.
+
 Version 1.2.3 (2010-10-11)
 * Server:
 ** Bug fix: Expose D-Bus API also in non-debug mode.

=== modified file 'README'
--- README	2010-09-26 18:32:58 +0000
+++ README	2011-02-27 17:26:35 +0000
@@ -162,8 +162,8 @@
 
 * Copyright
 
-    Copyright © 2008-2010 Teddy Hogeborn
-    Copyright © 2008-2010 Björn Påhlsson
+    Copyright © 2008-2011 Teddy Hogeborn
+    Copyright © 2008-2011 Björn Påhlsson
   
 ** License:
    

=== modified file 'common.ent'
--- common.ent	2010-10-11 17:45:21 +0000
+++ common.ent	2011-03-08 19:41:59 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.2.3">
+<!ENTITY version "1.3.0">

=== modified file 'debian/changelog'
--- debian/changelog	2010-10-11 17:45:21 +0000
+++ debian/changelog	2011-03-08 19:41:59 +0000
@@ -1,3 +1,15 @@
+mandos (1.3.0-1) unstable; urgency=low
+
+  * New upstream release.
+  * debian/control (mandos): Depend on Python 2.6, remove dependency on
+    python-multiprocessing.
+  (mandos-client): Conflict with dropbear (<< 0.52-5).
+  * debian/mandos-client.postrm (purge): Bug fix: update initramfs also on
+    purge.
+  * debian/mandos-client.lintian-overrides: Added plugins.d/plymouth.
+
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Tue, 08 Mar 2011 20:22:57 +0100
+
 mandos (1.2.3-1) experimental; urgency=low
 
   * New upstream release.

=== modified file 'debian/control'
--- debian/control	2010-10-01 18:40:55 +0000
+++ debian/control	2011-03-17 18:13:40 +0000
@@ -14,9 +14,9 @@
 
 Package: mandos
 Architecture: all
-Depends: ${misc:Depends}, python (>=2.5), python-gnutls, python-dbus,
+Depends: ${misc:Depends}, python (>=2.6), python-gnutls, python-dbus,
 	python-avahi, python-gobject, avahi-daemon, adduser,
-	python-urwid, python (>=2.6) | python-multiprocessing
+	python-urwid, python (>=2.7) | python-argparse
 Recommends: fping
 Description: a server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows
@@ -37,6 +37,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
 	gnupg (<< 2)
+Conflicts: dropbear (<= 0.52-5)
 Enhances: cryptsetup
 Description: do unattended reboots with an encrypted root file system
  This is the client part of the Mandos system, which allows

=== modified file 'debian/copyright'
--- debian/copyright	2010-09-26 18:32:58 +0000
+++ debian/copyright	2011-02-27 17:26:35 +0000
@@ -5,8 +5,8 @@
 Upstream-Source: <http://www.fukt.bsnet.se/mandos>
 
 Files: *
-Copyright: Copyright © 2008-2010 Teddy Hogeborn
-Copyright: Copyright © 2008-2010 Björn Påhlsson
+Copyright: Copyright © 2008-2011 Teddy Hogeborn
+Copyright: Copyright © 2008-2011 Björn Påhlsson
 License: GPL-3+
     This program is free software: you can redistribute it and/or
     modify it under the terms of the GNU General Public License as

=== modified file 'debian/mandos-client.postrm'
--- debian/mandos-client.postrm	2009-01-18 00:16:57 +0000
+++ debian/mandos-client.postrm	2011-02-27 17:00:41 +0000
@@ -45,6 +45,7 @@
 	rm --force /etc/mandos/plugin-runner.conf \
 	    /etc/keys/mandos/pubkey.txt \
 	    /etc/keys/mandos/seckey.txt 2>/dev/null
+	update_initramfs
 	;;
     upgrade|failed-upgrade|disappear|abort-install|abort-upgrade)
 	;;

=== modified file 'mandos'
--- mandos	2011-02-13 10:19:26 +0000
+++ mandos	2011-03-15 19:15:24 +0000
@@ -11,8 +11,8 @@
 # "AvahiService" class, and some lines in "main".
 # 
 # Everything else is
-# Copyright © 2008-2010 Teddy Hogeborn
-# Copyright © 2008-2010 Björn Påhlsson
+# Copyright © 2008-2011 Teddy Hogeborn
+# Copyright © 2008-2011 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -36,7 +36,7 @@
 
 import SocketServer as socketserver
 import socket
-import optparse
+import argparse
 import datetime
 import errno
 import gnutls.crypto
@@ -82,7 +82,7 @@
         SO_BINDTODEVICE = None
 
 
-version = "1.2.3"
+version = "1.3.0"
 
 #logger = logging.getLogger('mandos')
 logger = logging.Logger('mandos')
@@ -1409,7 +1409,7 @@
 
     def add_pipe(self, parent_pipe):
         """Dummy function; override as necessary"""
-        pass
+        raise NotImplementedError
 
 class IPv6_TCPServer(MultiprocessingMixInWithPipe,
                      socketserver.TCPServer, object):
@@ -1614,7 +1614,7 @@
             else:
                 raise ValueError("Unknown suffix %r" % suffix)
         except (ValueError, IndexError), e:
-            raise ValueError(e.message)
+            raise ValueError(*(e.args))
         timevalue += delta
     return timevalue
 
@@ -1673,34 +1673,37 @@
     ##################################################################
     # Parsing of options, both command line and config file
     
-    parser = optparse.OptionParser(version = "%%prog %s" % version)
-    parser.add_option("-i", "--interface", type="string",
-                      metavar="IF", help="Bind to interface IF")
-    parser.add_option("-a", "--address", type="string",
-                      help="Address to listen for requests on")
-    parser.add_option("-p", "--port", type="int",
-                      help="Port number to receive requests on")
-    parser.add_option("--check", action="store_true",
-                      help="Run self-test")
-    parser.add_option("--debug", action="store_true",
-                      help="Debug mode; run in foreground and log to"
-                      " terminal")
-    parser.add_option("--debuglevel", type="string", metavar="LEVEL",
-                      help="Debug level for stdout output")
-    parser.add_option("--priority", type="string", help="GnuTLS"
-                      " priority string (see GnuTLS documentation)")
-    parser.add_option("--servicename", type="string",
-                      metavar="NAME", help="Zeroconf service name")
-    parser.add_option("--configdir", type="string",
-                      default="/etc/mandos", metavar="DIR",
-                      help="Directory to search for configuration"
-                      " files")
-    parser.add_option("--no-dbus", action="store_false",
-                      dest="use_dbus", help="Do not provide D-Bus"
-                      " system bus interface")
-    parser.add_option("--no-ipv6", action="store_false",
-                      dest="use_ipv6", help="Do not use IPv6")
-    options = parser.parse_args()[0]
+    parser = argparse.ArgumentParser()
+    parser.add_argument("-v", "--version", action="version",
+                        version = "%%(prog)s %s" % version,
+                        help="show version number and exit")
+    parser.add_argument("-i", "--interface", metavar="IF",
+                        help="Bind to interface IF")
+    parser.add_argument("-a", "--address",
+                        help="Address to listen for requests on")
+    parser.add_argument("-p", "--port", type=int,
+                        help="Port number to receive requests on")
+    parser.add_argument("--check", action="store_true",
+                        help="Run self-test")
+    parser.add_argument("--debug", action="store_true",
+                        help="Debug mode; run in foreground and log"
+                        " to terminal")
+    parser.add_argument("--debuglevel", metavar="LEVEL",
+                        help="Debug level for stdout output")
+    parser.add_argument("--priority", help="GnuTLS"
+                        " priority string (see GnuTLS documentation)")
+    parser.add_argument("--servicename",
+                        metavar="NAME", help="Zeroconf service name")
+    parser.add_argument("--configdir",
+                        default="/etc/mandos", metavar="DIR",
+                        help="Directory to search for configuration"
+                        " files")
+    parser.add_argument("--no-dbus", action="store_false",
+                        dest="use_dbus", help="Do not provide D-Bus"
+                        " system bus interface")
+    parser.add_argument("--no-ipv6", action="store_false",
+                        dest="use_ipv6", help="Do not use IPv6")
+    options = parser.parse_args()
     
     if options.check:
         import doctest

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2010-09-27 18:57:12 +0000
+++ mandos-clients.conf.xml	2011-02-27 17:26:35 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2011-02-27">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -35,6 +35,7 @@
       <year>2008</year>
       <year>2009</year>
       <year>2010</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'mandos-ctl'
--- mandos-ctl	2010-10-11 17:45:21 +0000
+++ mandos-ctl	2011-03-15 20:13:05 +0000
@@ -22,73 +22,74 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-from __future__ import division
+from __future__ import (division, absolute_import, print_function,
+                        unicode_literals)
+
 import sys
 import dbus
-from optparse import OptionParser
+import argparse
 import locale
 import datetime
 import re
 import os
 
-locale.setlocale(locale.LC_ALL, u'')
+locale.setlocale(locale.LC_ALL, "")
 
 tablewords = {
-    'Name': u'Name',
-    'Enabled': u'Enabled',
-    'Timeout': u'Timeout',
-    'LastCheckedOK': u'Last Successful Check',
-    'LastApprovalRequest': u'Last Approval Request',
-    'Created': u'Created',
-    'Interval': u'Interval',
-    'Host': u'Host',
-    'Fingerprint': u'Fingerprint',
-    'CheckerRunning': u'Check Is Running',
-    'LastEnabled': u'Last Enabled',
-    'ApprovalPending': u'Approval Is Pending',
-    'ApprovedByDefault': u'Approved By Default',
-    'ApprovalDelay': u"Approval Delay",
-    'ApprovalDuration': u"Approval Duration",
-    'Checker': u'Checker',
+    "Name": "Name",
+    "Enabled": "Enabled",
+    "Timeout": "Timeout",
+    "LastCheckedOK": "Last Successful Check",
+    "LastApprovalRequest": "Last Approval Request",
+    "Created": "Created",
+    "Interval": "Interval",
+    "Host": "Host",
+    "Fingerprint": "Fingerprint",
+    "CheckerRunning": "Check Is Running",
+    "LastEnabled": "Last Enabled",
+    "ApprovalPending": "Approval Is Pending",
+    "ApprovedByDefault": "Approved By Default",
+    "ApprovalDelay": "Approval Delay",
+    "ApprovalDuration": "Approval Duration",
+    "Checker": "Checker",
     }
-defaultkeywords = ('Name', 'Enabled', 'Timeout', 'LastCheckedOK')
-domain = 'se.bsnet.fukt'
-busname = domain + '.Mandos'
-server_path = '/'
-server_interface = domain + '.Mandos'
-client_interface = domain + '.Mandos.Client'
-version = "1.2.3"
+defaultkeywords = ("Name", "Enabled", "Timeout", "LastCheckedOK")
+domain = "se.bsnet.fukt"
+busname = domain + ".Mandos"
+server_path = "/"
+server_interface = domain + ".Mandos"
+client_interface = domain + ".Mandos.Client"
+version = "1.3.0"
 
 def timedelta_to_milliseconds(td):
-    "Convert a datetime.timedelta object to milliseconds"
+    """Convert a datetime.timedelta object to milliseconds"""
     return ((td.days * 24 * 60 * 60 * 1000)
             + (td.seconds * 1000)
             + (td.microseconds // 1000))
 
 def milliseconds_to_string(ms):
     td = datetime.timedelta(0, 0, 0, ms)
-    return (u"%(days)s%(hours)02d:%(minutes)02d:%(seconds)02d"
+    return ("%(days)s%(hours)02d:%(minutes)02d:%(seconds)02d"
             % { "days": "%dT" % td.days if td.days else "",
                 "hours": td.seconds // 3600,
                 "minutes": (td.seconds % 3600) // 60,
                 "seconds": td.seconds % 60,
                 })
 
-
 def string_to_delta(interval):
     """Parse a string and return a datetime.timedelta
-
-    >>> string_to_delta('7d')
+    
+    >>> string_to_delta("7d")
     datetime.timedelta(7)
-    >>> string_to_delta('60s')
+    >>> string_to_delta("60s")
     datetime.timedelta(0, 60)
-    >>> string_to_delta('60m')
+    >>> string_to_delta("60m")
     datetime.timedelta(0, 3600)
-    >>> string_to_delta('24h')
+    >>> string_to_delta("24h")
     datetime.timedelta(1)
-    >>> string_to_delta(u'1w')
+    >>> string_to_delta("1w")
     datetime.timedelta(7)
-    >>> string_to_delta('5m 30s')
+    >>> string_to_delta("5m 30s")
     datetime.timedelta(0, 330)
     """
     timevalue = datetime.timedelta(0)
@@ -98,15 +99,15 @@
         try:
             suffix = unicode(s[-1])
             value = int(s[:-1])
-            if suffix == u"d":
+            if suffix == "d":
                 delta = datetime.timedelta(value)
-            elif suffix == u"s":
+            elif suffix == "s":
                 delta = datetime.timedelta(0, value)
-            elif suffix == u"m":
+            elif suffix == "m":
                 delta = datetime.timedelta(0, 0, 0, 0, value)
-            elif suffix == u"h":
+            elif suffix == "h":
                 delta = datetime.timedelta(0, 0, 0, 0, 0, value)
-            elif suffix == u"w":
+            elif suffix == "w":
                 delta = datetime.timedelta(0, 0, 0, 0, 0, 0, value)
             else:
                 raise ValueError
@@ -118,25 +119,25 @@
 def print_clients(clients, keywords):
     def valuetostring(value, keyword):
         if type(value) is dbus.Boolean:
-            return u"Yes" if value else u"No"
-        if keyword in (u"Timeout", u"Interval", u"ApprovalDelay",
-                       u"ApprovalDuration"):
+            return "Yes" if value else "No"
+        if keyword in ("Timeout", "Interval", "ApprovalDelay",
+                       "ApprovalDuration"):
             return milliseconds_to_string(value)
         return unicode(value)
     
     # Create format string to print table rows
-    format_string = u' '.join(u'%%-%ds' %
-                              max(len(tablewords[key]),
-                                  max(len(valuetostring(client[key],
-                                                        key))
-                                      for client in
-                                      clients))
-                              for key in keywords)
+    format_string = " ".join("%%-%ds" %
+                             max(len(tablewords[key]),
+                                 max(len(valuetostring(client[key],
+                                                       key))
+                                     for client in
+                                     clients))
+                             for key in keywords)
     # Print header line
-    print format_string % tuple(tablewords[key] for key in keywords)
+    print(format_string % tuple(tablewords[key] for key in keywords))
     for client in clients:
-        print format_string % tuple(valuetostring(client[key], key)
-                                    for key in keywords)
+        print(format_string % tuple(valuetostring(client[key], key)
+                                    for key in keywords))
 
 def has_actions(options):
     return any((options.enable,
@@ -156,182 +157,190 @@
                 options.secret is not None,
                 options.approve,
                 options.deny))
-        
+
 def main():
-	parser = OptionParser(version = "%%prog %s" % version)
-	parser.add_option("-a", "--all", action="store_true",
-	                  help="Select all clients")
-	parser.add_option("-v", "--verbose", action="store_true",
-	                  help="Print all fields")
-	parser.add_option("-e", "--enable", action="store_true",
-	                  help="Enable client")
-	parser.add_option("-d", "--disable", action="store_true",
-	                  help="disable client")
-	parser.add_option("-b", "--bump-timeout", action="store_true",
-	                  help="Bump timeout for client")
-	parser.add_option("--start-checker", action="store_true",
-	                  help="Start checker for client")
-	parser.add_option("--stop-checker", action="store_true",
-	                  help="Stop checker for client")
-	parser.add_option("-V", "--is-enabled", action="store_true",
-	                  help="Check if client is enabled")
-	parser.add_option("-r", "--remove", action="store_true",
-	                  help="Remove client")
-	parser.add_option("-c", "--checker", type="string",
-	                  help="Set checker command for client")
-	parser.add_option("-t", "--timeout", type="string",
-	                  help="Set timeout for client")
-	parser.add_option("-i", "--interval", type="string",
-	                  help="Set checker interval for client")
-        parser.add_option("--approve-by-default", action="store_true",
-                          dest=u"approved_by_default",
-                          help="Set client to be approved by default")
-        parser.add_option("--deny-by-default", action="store_false",
-                          dest=u"approved_by_default",
-                          help="Set client to be denied by default")
-        parser.add_option("--approval-delay", type="string",
-                          help="Set delay before client approve/deny")
-        parser.add_option("--approval-duration", type="string",
-                          help="Set duration of one client approval")
-	parser.add_option("-H", "--host", type="string",
-	                  help="Set host for client")
-	parser.add_option("-s", "--secret", type="string",
-	                  help="Set password blob (file) for client")
-	parser.add_option("-A", "--approve", action="store_true",
-	                  help="Approve any current client request")
-	parser.add_option("-D", "--deny", action="store_true",
-	                  help="Deny any current client request")
-	options, client_names = parser.parse_args()
-        
-        if has_actions(options) and not client_names and not options.all:
-            parser.error('Options require clients names or --all.')
-        if options.verbose and has_actions(options):
-            parser.error('--verbose can only be used alone or with'
-                         ' --all.')
-        if options.all and not has_actions(options):
-            parser.error('--all requires an action.')
-        
-        try:
-            bus = dbus.SystemBus()
-            mandos_dbus_objc = bus.get_object(busname, server_path)
-        except dbus.exceptions.DBusException:
-            print >> sys.stderr, "Could not connect to Mandos server"
-            sys.exit(1)
-    
-        mandos_serv = dbus.Interface(mandos_dbus_objc,
-                                     dbus_interface = server_interface)
-
-        #block stderr since dbus library prints to stderr
-        null = os.open(os.path.devnull, os.O_RDWR)
-        stderrcopy = os.dup(sys.stderr.fileno())
-        os.dup2(null, sys.stderr.fileno())
-        os.close(null)
-        try:
-            try:
-                mandos_clients = mandos_serv.GetAllClientsWithProperties()
-            finally:
-                #restore stderr
-                os.dup2(stderrcopy, sys.stderr.fileno())
-                os.close(stderrcopy)
-        except dbus.exceptions.DBusException, e:
-            print >> sys.stderr, "Access denied: Accessing mandos server through dbus."
-            sys.exit(1)
-            
-	# Compile dict of (clients: properties) to process
-	clients={}
-        
-        if options.all or not client_names:
-            clients = dict((bus.get_object(busname, path), properties)
-                           for path, properties in
-                           mandos_clients.iteritems())
-        else:
-            for name in client_names:
-                for path, client in mandos_clients.iteritems():
-                    if client['Name'] == name:
-                        client_objc = bus.get_object(busname, path)
-                        clients[client_objc] = client
-                        break
-                else:
-                    print >> sys.stderr, "Client not found on server: %r" % name
-                    sys.exit(1)
-            
-	if not has_actions(options) and clients:
-	    if options.verbose:
-	        keywords = ('Name', 'Enabled', 'Timeout',
-                            'LastCheckedOK', 'Created', 'Interval',
-                            'Host', 'Fingerprint', 'CheckerRunning',
-                            'LastEnabled', 'ApprovalPending',
-                            'ApprovedByDefault',
-                            'LastApprovalRequest', 'ApprovalDelay',
-                            'ApprovalDuration', 'Checker')
+    parser = argparse.ArgumentParser()
+    parser.add_argument("--version", action="version",
+                        version = "%%prog %s" % version,
+                        help="show version number and exit")
+    parser.add_argument("-a", "--all", action="store_true",
+                        help="Select all clients")
+    parser.add_argument("-v", "--verbose", action="store_true",
+                        help="Print all fields")
+    parser.add_argument("-e", "--enable", action="store_true",
+                        help="Enable client")
+    parser.add_argument("-d", "--disable", action="store_true",
+                        help="disable client")
+    parser.add_argument("-b", "--bump-timeout", action="store_true",
+                        help="Bump timeout for client")
+    parser.add_argument("--start-checker", action="store_true",
+                        help="Start checker for client")
+    parser.add_argument("--stop-checker", action="store_true",
+                        help="Stop checker for client")
+    parser.add_argument("-V", "--is-enabled", action="store_true",
+                        help="Check if client is enabled")
+    parser.add_argument("-r", "--remove", action="store_true",
+                        help="Remove client")
+    parser.add_argument("-c", "--checker",
+                        help="Set checker command for client")
+    parser.add_argument("-t", "--timeout",
+                        help="Set timeout for client")
+    parser.add_argument("-i", "--interval",
+                        help="Set checker interval for client")
+    parser.add_argument("--approve-by-default", action="store_true",
+                        default=None, dest="approved_by_default",
+                        help="Set client to be approved by default")
+    parser.add_argument("--deny-by-default", action="store_false",
+                        dest="approved_by_default",
+                        help="Set client to be denied by default")
+    parser.add_argument("--approval-delay",
+                        help="Set delay before client approve/deny")
+    parser.add_argument("--approval-duration",
+                        help="Set duration of one client approval")
+    parser.add_argument("-H", "--host", help="Set host for client")
+    parser.add_argument("-s", "--secret", type=file,
+                        help="Set password blob (file) for client")
+    parser.add_argument("-A", "--approve", action="store_true",
+                        help="Approve any current client request")
+    parser.add_argument("-D", "--deny", action="store_true",
+                        help="Deny any current client request")
+    parser.add_argument("client", nargs="*", help="Client name")
+    options = parser.parse_args()
+    
+    if has_actions(options) and not options.client and not options.all:
+        parser.error("Options require clients names or --all.")
+    if options.verbose and has_actions(options):
+        parser.error("--verbose can only be used alone or with"
+                     " --all.")
+    if options.all and not has_actions(options):
+        parser.error("--all requires an action.")
+    
+    try:
+        bus = dbus.SystemBus()
+        mandos_dbus_objc = bus.get_object(busname, server_path)
+    except dbus.exceptions.DBusException:
+        print("Could not connect to Mandos server",
+              file=sys.stderr)
+        sys.exit(1)
+    
+    mandos_serv = dbus.Interface(mandos_dbus_objc,
+                                 dbus_interface = server_interface)
+    
+    #block stderr since dbus library prints to stderr
+    null = os.open(os.path.devnull, os.O_RDWR)
+    stderrcopy = os.dup(sys.stderr.fileno())
+    os.dup2(null, sys.stderr.fileno())
+    os.close(null)
+    try:
+        try:
+            mandos_clients = mandos_serv.GetAllClientsWithProperties()
+        finally:
+            #restore stderr
+            os.dup2(stderrcopy, sys.stderr.fileno())
+            os.close(stderrcopy)
+    except dbus.exceptions.DBusException, e:
+        print("Access denied: Accessing mandos server through dbus.",
+              file=sys.stderr)
+        sys.exit(1)
+    
+    # Compile dict of (clients: properties) to process
+    clients={}
+    
+    if options.all or not options.client:
+        clients = dict((bus.get_object(busname, path), properties)
+                       for path, properties in
+                       mandos_clients.iteritems())
+    else:
+        for name in options.client:
+            for path, client in mandos_clients.iteritems():
+                if client["Name"] == name:
+                    client_objc = bus.get_object(busname, path)
+                    clients[client_objc] = client
+                    break
             else:
-                keywords = defaultkeywords
-            
-	    print_clients(clients.values(), keywords)
+                print("Client not found on server: %r" % name,
+                      file=sys.stderr)
+                sys.exit(1)
+    
+    if not has_actions(options) and clients:
+        if options.verbose:
+            keywords = ("Name", "Enabled", "Timeout",
+                        "LastCheckedOK", "Created", "Interval",
+                        "Host", "Fingerprint", "CheckerRunning",
+                        "LastEnabled", "ApprovalPending",
+                        "ApprovedByDefault",
+                        "LastApprovalRequest", "ApprovalDelay",
+                        "ApprovalDuration", "Checker")
         else:
-            # Process each client in the list by all selected options
-            for client in clients:
-                if options.remove:
-                    mandos_serv.RemoveClient(client.__dbus_object_path__)
-                if options.enable:
-                    client.Enable(dbus_interface=client_interface)
-                if options.disable:
-                    client.Disable(dbus_interface=client_interface)
-                if options.bump_timeout:
-                    client.CheckedOK(dbus_interface=client_interface)
-                if options.start_checker:
-                    client.StartChecker(dbus_interface=client_interface)
-                if options.stop_checker:
-                    client.StopChecker(dbus_interface=client_interface)
-                if options.is_enabled:
-                    sys.exit(0 if client.Get(client_interface,
-                                             u"Enabled",
-                                             dbus_interface=dbus.PROPERTIES_IFACE)
-                             else 1)
-                if options.checker:
-                    client.Set(client_interface, u"Checker", options.checker,
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.host:
-                    client.Set(client_interface, u"Host", options.host,
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.interval:
-                    client.Set(client_interface, u"Interval",
-                               timedelta_to_milliseconds
-                               (string_to_delta(options.interval)),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.approval_delay:
-                    client.Set(client_interface, u"ApprovalDelay",
-                               timedelta_to_milliseconds
-                               (string_to_delta(options.
-                                                approval_delay)),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.approval_duration:
-                    client.Set(client_interface, u"ApprovalDuration",
-                               timedelta_to_milliseconds
-                               (string_to_delta(options.
-                                                approval_duration)),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.timeout:
-                    client.Set(client_interface, u"Timeout",
-                               timedelta_to_milliseconds
-                               (string_to_delta(options.timeout)),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.secret:
-                    client.Set(client_interface, u"Secret",
-                               dbus.ByteArray(open(options.secret,
-                                                   u'rb').read()),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.approved_by_default is not None:
-                    client.Set(client_interface, u"ApprovedByDefault",
-                               dbus.Boolean(options
-                                            .approved_by_default),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.approve:
-                    client.Approve(dbus.Boolean(True),
-                                   dbus_interface=client_interface)
-                elif options.deny:
-                    client.Approve(dbus.Boolean(False),
-                                   dbus_interface=client_interface)
+            keywords = defaultkeywords
+        
+        print_clients(clients.values(), keywords)
+    else:
+        # Process each client in the list by all selected options
+        for client in clients:
+            if options.remove:
+                mandos_serv.RemoveClient(client.__dbus_object_path__)
+            if options.enable:
+                client.Enable(dbus_interface=client_interface)
+            if options.disable:
+                client.Disable(dbus_interface=client_interface)
+            if options.bump_timeout:
+                client.CheckedOK(dbus_interface=client_interface)
+            if options.start_checker:
+                client.StartChecker(dbus_interface=client_interface)
+            if options.stop_checker:
+                client.StopChecker(dbus_interface=client_interface)
+            if options.is_enabled:
+                sys.exit(0 if client.Get(client_interface,
+                                         "Enabled",
+                                         dbus_interface=
+                                         dbus.PROPERTIES_IFACE)
+                         else 1)
+            if options.checker:
+                client.Set(client_interface, "Checker",
+                           options.checker,
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+            if options.host:
+                client.Set(client_interface, "Host", options.host,
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+            if options.interval:
+                client.Set(client_interface, "Interval",
+                           timedelta_to_milliseconds
+                           (string_to_delta(options.interval)),
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+            if options.approval_delay:
+                client.Set(client_interface, "ApprovalDelay",
+                           timedelta_to_milliseconds
+                           (string_to_delta(options.
+                                            approval_delay)),
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+            if options.approval_duration:
+                client.Set(client_interface, "ApprovalDuration",
+                           timedelta_to_milliseconds
+                           (string_to_delta(options.
+                                            approval_duration)),
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+            if options.timeout:
+                client.Set(client_interface, "Timeout",
+                           timedelta_to_milliseconds
+                           (string_to_delta(options.timeout)),
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+            if options.secret:
+                client.Set(client_interface, "Secret",
+                           dbus.ByteArray(open(options.secret,
+                                               "rb").read()),
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+            if options.approved_by_default is not None:
+                client.Set(client_interface, "ApprovedByDefault",
+                           dbus.Boolean(options
+                                        .approved_by_default),
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+            if options.approve:
+                client.Approve(dbus.Boolean(True),
+                               dbus_interface=client_interface)
+            elif options.deny:
+                client.Approve(dbus.Boolean(False),
+                               dbus_interface=client_interface)
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     main()

=== modified file 'mandos-ctl.xml'
--- mandos-ctl.xml	2010-09-25 23:52:17 +0000
+++ mandos-ctl.xml	2011-02-27 17:26:35 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-ctl">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2011-02-27">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -32,6 +32,7 @@
     </authorgroup>
     <copyright>
       <year>2010</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'mandos-keygen'
--- mandos-keygen	2010-10-11 17:45:21 +0000
+++ mandos-keygen	2011-03-08 19:41:59 +0000
@@ -2,8 +2,8 @@
 # 
 # Mandos key generator - create a new OpenPGP key for a Mandos client
 # 
-# Copyright © 2008-2010 Teddy Hogeborn
-# Copyright © 2008-2010 Björn Påhlsson
+# Copyright © 2008-2011 Teddy Hogeborn
+# Copyright © 2008-2011 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-VERSION="1.2.3"
+VERSION="1.3.0"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA

=== modified file 'mandos-monitor'
--- mandos-monitor	2011-02-11 19:02:24 +0000
+++ mandos-monitor	2011-03-08 19:41:59 +0000
@@ -3,8 +3,8 @@
 # 
 # Mandos Monitor - Control and monitor the Mandos server
 # 
-# Copyright © 2009,2010 Teddy Hogeborn
-# Copyright © 2009,2010 Björn Påhlsson
+# Copyright © 2009-2011 Teddy Hogeborn
+# Copyright © 2009-2011 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -51,7 +51,7 @@
 domain = 'se.bsnet.fukt'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.2.3"
+version = "1.3.0"
 
 # Always run in monochrome mode
 urwid.curses_display.curses.has_colors = lambda : False

=== modified file 'mandos-monitor.xml'
--- mandos-monitor.xml	2010-09-30 06:24:20 +0000
+++ mandos-monitor.xml	2011-02-27 17:26:35 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-monitor">
-<!ENTITY TIMESTAMP "2010-09-14">
+<!ENTITY TIMESTAMP "2011-02-27">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -32,6 +32,7 @@
     </authorgroup>
     <copyright>
       <year>2010</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'mandos.lsm'
--- mandos.lsm	2010-10-11 17:45:21 +0000
+++ mandos.lsm	2011-03-08 19:41:59 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.2.3
-Entered-date:	2010-10-11
+Version:	1.3.0
+Entered-date:	2011-03-08
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@fukt.bsnet.se (Teddy Hogeborn),
 		belorn@fukt.bsnet.se (Björn Påhlsson)
 Primary-site: http://www.fukt.bsnet.se/mandos
-	      133K mandos_1.2.3.orig.tar.gz
+	      133K mandos_1.3.0.orig.tar.gz
 Alternate-site: ftp://ftp.fukt.bsnet.se/pub/mandos
-		133K mandos_1.2.3.orig.tar.gz
+		133K mandos_1.3.0.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.5, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.

=== modified file 'mandos.xml'
--- mandos.xml	2010-09-27 17:39:03 +0000
+++ mandos.xml	2011-02-27 17:26:35 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2011-02-27">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -34,6 +34,7 @@
       <year>2008</year>
       <year>2009</year>
       <year>2010</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2010-09-26 18:32:58 +0000
+++ plugins.d/askpass-fifo.c	2011-02-27 17:26:35 +0000
@@ -2,8 +2,8 @@
 /*
  * Askpass-FIFO - Read a password from a FIFO and output it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2010-09-26 21:27:28 +0000
+++ plugins.d/mandos-client.c	2011-02-27 17:26:35 +0000
@@ -9,8 +9,8 @@
  * "browse_callback", and parts of "main".
  * 
  * Everything else is
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2010-11-05 18:30:07 +0000
+++ plugins.d/password-prompt.c	2011-03-08 11:08:35 +0000
@@ -24,7 +24,7 @@
 
 #define _GNU_SOURCE		/* getline(), asprintf() */
 
-#include <termios.h> 		/* struct termios, tcsetattr(),
+#include <termios.h>		/* struct termios, tcsetattr(),
 				   TCSAFLUSH, tcgetattr(), ECHO */
 #include <unistd.h>		/* struct termios, tcsetattr(),
 				   STDIN_FILENO, TCSAFLUSH,
@@ -35,7 +35,8 @@
 				   SIGQUIT, SIGHUP, SIGTERM,
 				   raise() */
 #include <stddef.h>		/* NULL, size_t, ssize_t */
-#include <sys/types.h>		/* ssize_t, struct dirent, pid_t, ssize_t */
+#include <sys/types.h>		/* ssize_t, struct dirent, pid_t,
+				   ssize_t, open() */
 #include <stdlib.h>		/* EXIT_SUCCESS, EXIT_FAILURE,
 				   getenv(), free() */
 #include <dirent.h>		/* scandir(), alphasort() */
@@ -49,8 +50,8 @@
 #include <iso646.h>		/* or, not */
 #include <stdbool.h>		/* bool, false, true */
 #include <inttypes.h>		/* strtoumax() */
-#include <sys/stat.h> 		/* struct stat, lstat() */
-#include <string.h> 		/* strlen, rindex, memcmp */
+#include <sys/stat.h>		/* struct stat, lstat(), open() */
+#include <string.h>		/* strlen, rindex, memcmp */
 #include <argp.h>		/* struct argp_option, struct
 				   argp_state, struct argp,
 				   argp_parse(), error_t,
@@ -58,6 +59,7 @@
 				   ARGP_ERR_UNKNOWN */
 #include <sysexits.h>		/* EX_SOFTWARE, EX_OSERR,
 				   EX_UNAVAILABLE, EX_IOERR, EX_OK */
+#include <fcntl.h>		/* open() */
 
 volatile sig_atomic_t quit_now = 0;
 int signal_received;
@@ -65,9 +67,8 @@
 const char *argp_program_version = "password-prompt " VERSION;
 const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
 
-/* Needed for conflic resolution */
-const char plymouthd_path[] = "/sbin/plymouth";
-
+/* Needed for conflict resolution */
+const char plymouth_name[] = "plymouthd";
 
 static void termination_handler(int signum){
   if(quit_now){
@@ -79,12 +80,13 @@
 
 bool conflict_detection(void){
 
-  /* plymouth conflicts with password-promt since both want to control the
-     associated terminal. Password-prompt exit since plymouth perferms the same
-     functionallity.
+  /* plymouth conflicts with password-prompt since both want to read
+     from the terminal.  Password-prompt will exit if it detects
+     plymouth since plymouth performs the same functionality.
    */
   int is_plymouth(const struct dirent *proc_entry){
     int ret;
+    int cl_fd;
     {
       uintmax_t maxvalue;
       char *tmp;
@@ -96,52 +98,96 @@
 	return 0;
       }
     }
-    char exe_target[sizeof(plymouthd_path)];
-    char *exe_link;
-    ret = asprintf(&exe_link, "/proc/%s/exe", proc_entry->d_name);
+    
+    char *cmdline_filename;
+    ret = asprintf(&cmdline_filename, "/proc/%s/cmdline",
+		   proc_entry->d_name);
     if(ret == -1){
       error(0, errno, "asprintf");
       return 0;
     }
-  
-    struct stat exe_stat;
-    ret = lstat(exe_link, &exe_stat);
-    if(ret == -1){
-      free(exe_link);
-      if(errno != ENOENT){
-	error(0, errno, "lstat");
-      }
-      return 0;
-    }
-  
-    if(not S_ISLNK(exe_stat.st_mode)
-       or exe_stat.st_uid != 0
-       or exe_stat.st_gid != 0){
-      free(exe_link);
-      return 0;
-    }
-  
-    ssize_t sret = readlink(exe_link, exe_target, sizeof(exe_target));
-    free(exe_link);
-    if((sret != (ssize_t)sizeof(plymouthd_path)-1) or
-       (memcmp(plymouthd_path, exe_target,
-	       sizeof(plymouthd_path)-1) != 0)){
-      return 0;
-    }
+    
+    /* Open /proc/<pid>/cmdline */
+    cl_fd = open(cmdline_filename, O_RDONLY);
+    free(cmdline_filename);
+    if(cl_fd == -1){
+      error(0, errno, "open");
+      return 0;
+    }
+    
+    char *cmdline = NULL;
+    {
+      size_t cmdline_len = 0;
+      size_t cmdline_allocated = 0;
+      char *tmp;
+      const size_t blocksize = 1024;
+      ssize_t sret;
+      do {
+	/* Allocate more space? */
+	if(cmdline_len + blocksize + 1 > cmdline_allocated){
+	  tmp = realloc(cmdline, cmdline_allocated + blocksize + 1);
+	  if(tmp == NULL){
+	    error(0, errno, "realloc");
+	    free(cmdline);
+	    close(cl_fd);
+	    return 0;
+	  }
+	  cmdline = tmp;
+	  cmdline_allocated += blocksize;
+	}
+	
+	/* Read data */
+	sret = read(cl_fd, cmdline + cmdline_len,
+		    cmdline_allocated - cmdline_len);
+	if(sret == -1){
+	  error(0, errno, "read");
+	  free(cmdline);
+	  close(cl_fd);
+	  return 0;
+	}
+	cmdline_len += (size_t)sret;
+      } while(sret != 0);
+      ret = close(cl_fd);
+      if(ret == -1){
+	error(0, errno, "close");
+	free(cmdline);
+	return 0;
+      }
+      cmdline[cmdline_len] = '\0'; /* Make sure it is terminated */
+    }
+    /* we now have cmdline */
+    
+    /* get basename */
+    char *cmdline_base = strrchr(cmdline, '/');
+    if(cmdline_base != NULL){
+      cmdline_base += 1;		/* skip the slash */
+    } else {
+      cmdline_base = cmdline;
+    }
+    
+    if(strcmp(cmdline_base, plymouth_name) != 0){
+      if(debug){
+	fprintf(stderr, "\"%s\" is not \"%s\"\n", cmdline_base,
+		plymouth_name);
+      }
+      free(cmdline);
+      return 0;
+    }
+    if(debug){
+      fprintf(stderr, "\"%s\" equals \"%s\"\n", cmdline_base,
+	      plymouth_name);
+    }
+    free(cmdline);
     return 1;
   }
-
+  
   struct dirent **direntries;
   int ret;
   ret = scandir("/proc", &direntries, is_plymouth, alphasort);
   if (ret == -1){
     error(1, errno, "scandir");
   }
-  if (ret < 0){
-    return 1;
-  } else {
-    return 0;
-  }
+  return ret > 0;
 }
 
 
@@ -229,7 +275,7 @@
 
   if (conflict_detection()){
     if(debug){
-      fprintf(stderr, "Stopping %s because of conflict", argv[0]);
+      fprintf(stderr, "Stopping %s because of conflict\n", argv[0]);
     }
     return EXIT_FAILURE;
   }
@@ -437,8 +483,8 @@
 	break;
       }
     }
-    /* if(sret == 0), then the only sensible thing to do is to retry to
-       read from stdin */
+    /* if(sret == 0), then the only sensible thing to do is to retry
+       to read from stdin */
     fputc('\n', stderr);
     if(debug and not quit_now){
       /* If quit_now is nonzero, we were interrupted by a signal, and

=== modified file 'plugins.d/plymouth.c'
--- plugins.d/plymouth.c	2010-11-16 18:10:22 +0000
+++ plugins.d/plymouth.c	2011-02-27 17:26:35 +0000
@@ -2,8 +2,8 @@
 /*
  * Plymouth - Read a password from Plymouth and output it
  * 
- * Copyright © 2010 Teddy Hogeborn
- * Copyright © 2010 Björn Påhlsson
+ * Copyright © 2010-2011 Teddy Hogeborn
+ * Copyright © 2010-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugins.d/plymouth.xml'
--- plugins.d/plymouth.xml	2010-09-26 18:32:58 +0000
+++ plugins.d/plymouth.xml	2011-02-27 17:26:35 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plymouth">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2011-02-27">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -32,6 +32,7 @@
     </authorgroup>
     <copyright>
       <year>2010</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2010-10-07 17:46:56 +0000
+++ plugins.d/splashy.c	2011-02-27 17:26:35 +0000
@@ -2,8 +2,8 @@
 /*
  * Splashy - Read a password from splashy and output it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2010-09-26 18:32:58 +0000
+++ plugins.d/usplash.c	2011-02-27 17:26:35 +0000
@@ -2,8 +2,8 @@
 /*
  * Usplash - Read a password from usplash and output it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

